/******************************************************************************
 * File/main.cpp = Kopf der Hauptdatei und deren Beschreibungen.              *
 ******************************************************************************/

/******* Include files ********************************************************/
#include "main.hpp"

using namespace std;


/******* Declaration form variable ********************************************/



/******* Forward declaration of function **************************************/


/******************************************************************************
 * FLile _ LIST                                                               *
 ******************************************************************************/
int fl_list(string strPfad)
{
/******* Declaration form variable ********************************************/
char caZk[256];   // Hilfszeichenkette mit maximal 256 Zeichen inklusive NULL.

int
 iA=0,   // Anzahl der Eintraege in einem Verzeichnis.
 iTyp=0;   // Typ eines Verzeichniseintrages: Verzeichnis, Datei, ....

string
 strDName="";   // Name einer Datei mit ???

struct stat Status;

DIR *pVerz0;   // Zeiger auf den Verzeichniseintrag im Datentraeger.
dirent *pVerz1;   // Dateieintrag im Verzeichnis des Datentrgers.

/******* Initialisierung ******************************************************/
cout << endl
     << "Verzeichnisinformationen auslesen\n"
     << "---------------------------------" << endl;
pVerz0=opendir(strPfad.c_str());
if (pVerz0) {
 cout << "Das Verzeichnis DIR *pVerz0 existiert und hat folgende Daten: " << endl;
 cout << "- dd_dta" << endl;
 cout << "  . attrib: " << pVerz0->dd_dta.attrib << endl;
 cout << "  . name: " << pVerz0->dd_dta.name << endl;
 cout << "  . size: " << pVerz0->dd_dta.size << endl;
 cout << "  . time_access: " << pVerz0->dd_dta.time_access << endl;
 cout << "  . time_create: " << pVerz0->dd_dta.time_create << endl;
 cout << "  . time_write: " << pVerz0->dd_dta.time_write << endl;
 cout << "- dd_dir" << endl;
 cout << "  . d_ino: " << pVerz0->dd_dir.d_ino << endl;
 cout << "  . d_name: " << pVerz0->dd_dir.d_name << endl;
 cout << "  . d_namlen: " << pVerz0->dd_dir.d_namlen << endl;
 cout << "  . d_reclen: " << pVerz0->dd_dir.d_reclen << endl;
 cout << "- dd_handle: " << pVerz0->dd_handle << endl;
 cout << "- dd_name: " << pVerz0->dd_name << endl;
 cout << "- dd_stat: " << pVerz0->dd_stat << endl;

 /******* Eintraege im Verzeichnis auslesen und auflisten. ********************/
 cout << "Der jeweilige Verzeichnis-Eintrag dirent *pVerz1 existiert und "
          "hat jeweils folgende Daten: "
      << endl;
 iA=0;
 while (NULL != (pVerz1=readdir(pVerz0))) {
  iA++;
  cout << "- Dateiname: " << pVerz1->d_name << endl;
  cout << "  d_ino: " << pVerz1->d_ino << endl;
  cout << "  d_reclen: " << pVerz1->d_reclen << endl;
  cout << "  d_namlen: " << pVerz1->d_namlen << endl;
  cout << "  d_reclen: " << pVerz1->d_reclen << endl;

  stat(pVerz1->d_name, &Status);
  cout << "  stat(strDName.c_str(), &Status);" << endl;
  cout << "  - dev_t st_dev: " << Status.st_dev << endl;
  cout << "  - ushort st_ino: " << Status.st_ino << endl;

  sprintf(caZk, " rwx fuer ugo: %oO %XH", Status.st_mode, Status.st_mode);
  cout << "  - ushort st_mode: " << caZk << " -> ";
  iTyp=Status.st_mode & S_IFMT;
  switch (iTyp) {
   case S_IFREG: cout << "Datei"; break;
//   case S_IFLNK: puts("Symbolischer Link"); break;
   case S_IFDIR: cout << "Verzeichnis"; break;
   default: cout << "Sonstiges";
   }   // switch (iTyp)
  cout << endl;
  cout << "  - short  st_nlink: " << Status.st_nlink << endl;
  cout << "  - ushort st_uid: " << Status.st_uid << endl;
  cout << "  - ushort st_gid: " << Status.st_gid << endl;
  cout << "  - dev_t  st_rdev: " << Status.st_rdev << endl;
  cout << "  - off_t  st_size: " << Status.st_size << endl;
  cout << "  - time_t st_atime: " << Status.st_atime << endl;
  cout << "  - time_t st_mtime: " << Status.st_mtime << endl;
  cout << "  - time_t st_ctime: " << Status.st_ctime << endl;
  cout << endl;
  }   // while (NULL != (pVerz1=readdir(pVerz0)))
 cout << "Anzahl der Verzeichniss-Eintraege: " << iA << " Stueck." << endl;
 }   // if (pVerz0)
else {
 cerr << "Verzeichnis . konnte nicht geffnet werden!" << endl;
 return EXIT_FAILURE;
 }

/******* Funktion schlieszen und beenden! *************************************/
closedir(pVerz0);
return 0;
}   // void fl_list(...)


/******************************************************************************
 * FiLe _ WRITE                                                               *
 ******************************************************************************/
int fl_write(string strPfad, string strDatei)
{

/******* Declaration form variable ********************************************/
string
 strLogBuch=strPfad+"\\"+strDatei,   // Datei-Name des Logbuchs.
 strText="";   // Ein Text.

ofstream *phLogBuch;   // Haendel der Ausgabe-Datei fr das Logbuch.

phLogBuch = new ofstream(strLogBuch.c_str(),
            ios_base::out|ios_base::binary|ios_base::trunc);
if (phLogBuch->good())
 {
 strText="Hallo Datei LogBuch!";
 cout << "Text: " << strText << ", Groesze: " << strText.size() << endl;
 phLogBuch->write(strText.c_str(), strText.size());
 phLogBuch->flush();

 strText="Zweite Zeile. \n Und ein Zeilenumbruch zuvor!";
 cout << "Text: " << strText << ", Groesze: " << strText.size() << endl;
 phLogBuch->write(strText.c_str(), strText.size());
 phLogBuch->flush();
 }   // if (phLogBuch->good())
else {
 cerr << "Die Datei wurde NICHT erfolgreich geoeffnet und beschrieben!" << endl;
 return EXIT_FAILURE;
 }

/******* Funktion schlieszen und beenden! *************************************/
delete phLogBuch;
return EXIT_SUCCESS;
}   // void fl_write()


/******************************************************************************
 * fl2bak = File ZU BAKup                                                     *
 ******************************************************************************/
fl2bak(string strPfad, string strDatei)
{
/******* Definition von Konstanten ********************************************/

/******* Deklaration von Variablen ********************************************/
int iE=0;   // Ergebnis;
string strBackup;   // Name der originalen Datei und als Typ BAK

/******* Backup-Dateinamen plus Typ erstellen. ********************************/
iE=strDatei.find_last_of('.');
strBackup=strDatei.substr(0, iE)+".BAK";

iE=chdir(strPfad.c_str());
if (0 > iE) {
 cout << "Verzeichnis " << strPfad << " nicht gefunden!" << endl;
 return EXIT_FAILURE;
 }   // if (0 > iE)
strPfad.clear();
strPfad=".\\"+strDatei;
if (0 > (iE=remove(strBackup.c_str())))
 cout << "Datei " << strBackup
      << " konnte nicht geloescht (Existenz, Rechte) werden!" << endl;

iE=rename(strPfad.c_str(), strBackup.c_str());
if (0 > iE) {
 cout << "Backup von " << strBackup << " in " << strPfad
      << " konnte nicht umbenannt (Existenz, Rechte) werden!" << endl;
 return EXIT_FAILURE;
 }   // if (0 > iE)

/******* Funktion schlieszen und beenden! *************************************/
return EXIT_SUCCESS;
}   // fren2bak(string strPfad, string strDatei, string strBackup)


/******************************************************************************
 * main = Kopf der Hauptdatei und deren Beschreibungen.                       *
 ******************************************************************************/
int main(int iArg, char* pszArgs[], char* pszEnv[])
{
/******* Definition von Konstanten ********************************************/

/******* Deklaration von Variablen ********************************************/
extern short int unsigned gwFehler;   // Siehe MAIN.HPP

int
 iE=0,   // Ergebnis
 // iI=0, iJ=0,   // Hilfszaehler
 iNr=0;   // Nummer des Beispiels

 string strEins, strZwei, strDrei;   // Drei Hilfsstrings zur Datenein- und -ausgabe.


iNr++;
cout << endl
     << iNr
     << ". Auflisten der Informationen aller Dateien in einem Verzeichnis;\n"
     << "------------------------------------------------------------------"
     << endl;
strEins="C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp";
strZwei="*.TXT";
cout << "Gegeben:\n"
     << "- Pfad: " << strEins <<  endl;
iE=fl_list(strEins);

iNr++;
cout << endl
     << iNr
     << ". Datei oeffnen, etwas hinein schreiben und schlieszen;\n"
     << "--------------------------------------------------------"
     << endl;
strEins="C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp";
strZwei="LogBuch.TXT";
cout << "Gegeben:\n"
     << "- Pfad: " << strEins << "\n"
     << "- Datei: " << strZwei << endl;
iE=fl_write(strEins, strZwei);

iNr++;
cout << endl
     << iNr
     << ". Eine vorhandene Datei in ein Backup umbenennen;\n"
     << "-------------------------------------------------"
     << endl;
strEins="C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp";
strZwei="LogBuch.TXT";
cout << "Gegeben:\n"
     << "- Pfad: " << strEins << "\n"
     << "- bisheriger Dateiname.Typ: " << strZwei << endl;

iE=fl2bak(strEins, strZwei);

/******* Programm schlieszen und beenden! *************************************/
iNr++;
cout << endl
     << iNr
     << ". Programm File v1.000 schlieszen und Beenden.\n"
     << "-----------------------------------------------"
     << endl;

return gwFehler;
}   // int main(int iArg, char* pszArgs[], char* pszEnv[])
/******* EOF ******************************************************************/
